<template>
  <template v-if="allowCompany && isStyleThree">
    <lazy-m-header-style-module-left-side-bar-style-3 />
  </template>
  <div v-else id="right-menu-drawer-main" class="sidebar">
    <el-dialog
      v-model="showSidebar"
      :before-close="toggleSidebar"
      destroy-on-close
      width="260px"
      custom-class="sidebar-dialog"
      :class="isUseV2LayoutStyle ? 'outline-none' : ''"
      :show-close="false"
    >
      <div class="flex flex-col items-center gap-2 py-2">
        <div
          v-if="menuTabHeaders.length > 0"
          class="flex flex-col items-start w-full p-0 gap-2"
        >
          <new-black-theme-sidebar-menu
            v-for="menu in menuTabHeaders"
            :key="menu"
            :menu="menu"
          />
        </div>
        <template v-if="isAllowPromotionTab">
          <div class="menu-drawer-divider"></div>
          <nuxt-link
            :id="ID.TAB_TYPE_MOBILE_RIGHT_SIDE_BAR.PROMOTION"
            to="/Promotion"
            class="w-full flex items-center justify-between py-1 pl-3 pr-4"
            @click="toggleSidebar"
          >
            <div
              class="flex justify-between items-center w-full pointer-events-none"
            >
              <div
                :class="[
                  'flex items-center relative',
                  isUseV2LayoutStyle ? 'main-menu-active-container' : 'gap-2',
                  { 'menu-active': isPromotionActived },
                ]"
              >
                <div :class="isUseV2LayoutStyle ? 'p-2' : 'w-5 h-5'">
                  <svg-icon
                    svg-name="icon-promotion-2"
                    style="fill: currentColor"
                    class="icon tc-5"
                    :class="[
                      { 'menu-active': isPromotionActived },
                      isUseV2LayoutStyle
                        ? 'w-[24px] h-[24px]'
                        : 'w-[17px] h-[17px]',
                    ]"
                  />
                </div>
                <span
                  :class="[
                    'uppercase',
                    isPromotionActived ? 'menu-active' : 'sidebar-text',
                  ]"
                >
                  {{ $t("promotion") }}
                </span>
              </div>
              <div
                v-if="!isPromotionActived"
                class="flex items-center m-angle-right-container"
              >
                <font-awesome-icon
                  icon="angle-right"
                  class="icon-angle-right"
                />
              </div>
            </div>
          </nuxt-link>
        </template>
        <div class="menu-drawer-divider"></div>
        <button
          v-if="!agentCooperation.IsHidden"
          class="flex justify-between items-center py-1 w-full pl-3 pr-4"
          type="button"
          @click="toggleAgentCooperation"
        >
          <div
            class="flex items-center overflow-x-hidden"
            :class="isUseV2LayoutStyle ? '' : 'gap-2'"
          >
            <div :class="isUseV2LayoutStyle ? 'p-2' : 'w-5 h-5'">
              <svg-icon
                svg-name="icon-people"
                class="icon tc-5"
                :class="
                  isUseV2LayoutStyle ? 'w-[24px] h-[24px]' : 'w-[17px] h-[17px]'
                "
                style="fill: currentColor"
              />
            </div>
            <span class="sidebar-text">{{ $t("agent_cooperation") }}</span>
          </div>
          <div class="flex items-center m-angle-right-container">
            <font-awesome-icon icon="angle-right" />
          </div>
        </button>
        <nuxt-link
          v-if="getContactList.length"
          to="/contact-us"
          class="w-full flex items-center justify-between py-1 pl-3 pr-4 tc-5"
          @click="toggleSidebar"
        >
          <div class="flex justify-between items-center w-full">
            <div
              :class="[
                'flex items-center relative',
                isUseV2LayoutStyle ? 'main-menu-active-container' : 'gap-2',
                { 'menu-active': isContactActive },
              ]"
            >
              <div :class="isUseV2LayoutStyle ? 'p-2' : 'w-5 h-5'">
                <IconContacts
                  :class="[
                    isUseV2LayoutStyle
                      ? 'w-[24px] h-[24px]'
                      : 'w-[17px] h-[17px]',
                  ]"
                />
              </div>
              <span
                :class="[
                  'uppercase',
                  isContactActive ? 'menu-active' : 'sidebar-text',
                ]"
              >
                {{ $t("contact") }}
              </span>
            </div>
            <div
              v-if="!isContactActive"
              class="flex items-center m-angle-right-container"
            >
              <font-awesome-icon icon="angle-right" class="icon-angle-right" />
            </div>
          </div>
        </nuxt-link>
        <UtilsMobileLanguageSelection
          class="w-full"
          @expanded="onLanguageExpanded"
        />
      </div>
      <template v-if="isAppDownloadEnabled">
        <div class="h-16"></div>
        <a
          v-if="appDownloadURL === ''"
          :href="appUrl"
          class="fixed bottom-0"
          :class="[isBk8Green ? 'left-0' : 'right-0']"
          download
        >
          <div class="rounded-t-2xl bg-theme-color">
            <div class="flex items-end justify-between h-16 gap-1 px-1">
              <div class="w-[68px] h-[68px]">
                <img
                  :src="
                    getAssetImage(
                      'assets/theme/new_black_theme/app_download.png'
                    )
                  "
                  alt=""
                />
              </div>
              <div class="flex items-center p-0 gap-1 h-16 z-[1]">
                <div
                  class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                >
                  <span class="app-download-title">{{ brandName }} APP</span>
                  <span class="app-download-content"
                    >Download <br />
                    our Android APP</span
                  >
                </div>
                <div class="w-[78px] h-[30px]">
                  <el-button
                    :type="theme == 'bk8' ? 'primary' : 'danger'"
                    round
                    class="capitalize bk8-downloadBtn"
                    >{{ $t("download") }}</el-button
                  >
                </div>
              </div>
            </div>
            <div
              class="bg-app-download"
              :style="`background-image: ${bgApp};`"
            ></div>
          </div>
        </a>
        <a
          v-else
          :href="
            appDownloadURL.includes('://')
              ? appDownloadURL
              : `//${appDownloadURL}`
          "
          target="_blank"
          class="fixed bottom-0"
          :class="[isBk8Green ? 'left-0' : 'right-0']"
        >
          <div class="rounded-t-2xl bg-theme-color">
            <div class="flex items-end justify-between h-16 gap-1 px-1">
              <div class="w-[68px] h-[68px]">
                <img
                  :src="
                    getAssetImage(
                      'assets/theme/new_black_theme/app_download.png'
                    )
                  "
                  alt=""
                />
              </div>
              <div class="flex items-center p-0 gap-1 h-16 z-[1]">
                <div
                  class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                >
                  <span class="app-download-title">{{ brandName }} APP</span>
                  <span class="app-download-content"
                    >Download <br />
                    our Android APP</span
                  >
                </div>
                <div class="w-[78px] h-[30px]">
                  <el-button
                    :type="theme == 'bk8' ? 'primary' : 'danger'"
                    round
                    class="capitalize bk8-downloadBtn"
                    >{{ $t("download") }}</el-button
                  >
                </div>
              </div>
            </div>
            <div
              class="bg-app-download"
              :style="`background-image: ${bgApp};`"
            ></div>
          </div>
        </a>
      </template>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import { useRoute } from "vue-router";
import { store } from "@/store";
import {
  useHeaderComponent,
  useLanguageComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import IconContacts from "~/assets/icons/contacts.svg?component";
import IconPromotion from "@/assets/icons/promotion.svg?component";

export default defineComponent({
  name: "Login",
  components: { IconContacts, IconPromotion },
  setup() {
    const authentication = computed(() => store.state.auth);
    const { getContactList } = useContactUs();
    const selectedThemeName = store.state.selectedThemeName;
    store.commit("updateSidebar", false);
    // store.commit("updateRegisterDialog", false);
    store.commit("updateAgentCooperationDialog", false);
    const toggleSidebar = () => {
      store.commit("updateSidebar", !store.state.showSidebar);
    };
    const toggleAgentCooperation = () => {
      store.commit(
        "updateAgentCooperationDialog",
        !store.state.showAgentCooperationDialog
      );
    };
    const showSidebar = computed(() => store.state.showSidebar);
    const authenticated = computed(() => store.state.auth);
    const activeNames = ref([]);
    const { getAssetImage } = commonHelper;
    const handleImageRender = (img: string) => {
      let src = "";
      try {
        src = getAssetImage(
          `assets/theme/new_black_theme/sidebar/${img.replace(" ", "")}.svg`
        );
      } catch (_) {
        src = "";
      }
      return src;
    };
    const scrollToTop = () => {
      setTimeout(() => {
        const el = document.getElementsByClassName("language-option");
        const wrapper = document
          .getElementById("right-menu-drawer-main")
          ?.getElementsByClassName("el-overlay")[0]
          ?.getElementsByClassName("el-overlay-dialog")[0];
        const wrapperRect = (wrapper as HTMLElement)?.getBoundingClientRect();
        const targetRect = (
          el[el.length - 1] as HTMLElement
        )?.getBoundingClientRect();
        const scrollTop =
          targetRect.top -
          wrapperRect.top +
          (wrapper as HTMLElement)?.scrollTop;
        (wrapper as HTMLElement)?.scrollTo({
          top: scrollTop,
          behavior: "smooth",
        });
      }, 300);
    };
    watch(activeNames, (value) => {
      if (value.toString() === "language") {
        scrollToTop();
      }
    });
    const {
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
    } = useLanguageComponent();
    const {
      menuTabHeaders,
      appDownload,
      appUrl,
      appDownloadURL,
      isAppDownloadEnabled,
      isAllowPromotionTab,
      agentCooperation,
    } = useHeaderComponent();
    const bgApp = `url(${getAssetImage(
      "assets/theme/new_black_theme/bg-app-download.png"
    )})`;
    const brandName = themePropertyHelper.getSingleThemeProperty(
      store.state.companyThemePropertiesFromApi.ThemeProperties,
      "seo_brand_name"
    ).Text;
    const { themeColor } = themePropertyHelper;
    const theme = themeColor.value.Text;
    const isMain = computed(() =>
      store.state.companyThemePropertiesFromApi.ThemeProperties[0].ThemeName.toLowerCase().includes(
        "main"
      )
    );
    const isBk8Green = computed(() => themeColor.value.Text === "bk8_green");

    const isUseV2LayoutStyle = computed(
      () =>
        isBk8Green.value ||
        isMain.value ||
        themeColor.value.Text.includes("bk8") ||
        document.body.getAttribute("layout-version") === "2"
    );
    const route = useRoute();
    const { path } = toRefs(route);
    const isPromotionActived = computed(
      () => path.value.toLocaleLowerCase() === "/promotion"
    );
    const isContactActive = computed(() =>
      String(path.value).toLowerCase().includes("contact")
    );
    const onLanguageExpanded = (lastEl: HTMLElement) => {
      setTimeout(() => {
        const y = lastEl.getBoundingClientRect().top + window.pageYOffset - 100;
        const el = document.getElementsByClassName("sidebar-dialog");
        el?.[0]?.scrollTo({ top: y, behavior: "smooth" });
      }, 100);
    };
    const themeProperties =
      store.state.companyThemePropertiesFromApi.ThemeProperties;
    const headerStyle = themePropertyHelper.getSingleThemeProperty(
      themeProperties,
      "header_style"
    );
    const isStyleThree = headerStyle.Text === "header_3";
    const { allowCompany } = commonHelper;
    return {
      toggleSidebar,
      showSidebar,
      menuTabHeaders,
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
      activeNames,
      appDownload,
      appUrl,
      handleImageRender,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      authenticated,
      getAssetImage,
      bgApp,
      isAppDownloadEnabled,
      isAllowPromotionTab,
      toggleAgentCooperation,
      authentication,
      agentCooperation,
      brandName,
      selectedThemeName,
      theme,
      isMain,
      isPromotionActived,
      isContactActive,
      getContactList,
      onLanguageExpanded,
      isBk8Green,
      isUseV2LayoutStyle,
      isStyleThree,
      allowCompany,
      appDownloadURL,
    };
  },
});
</script>

<style lang="scss" scoped>
:deep(.el-collapse-item__content) {
  padding-bottom: 0;
}
.menu-drawer-divider {
  width: 100%;
  height: 1px;
  background: var(--border);
}
:deep(button.el-button) {
  width: 78px;
  height: 30px;
  background-color: var(--primary);
  border: none;
}
:deep(.el-button span) {
  @apply text-[12px] font-bold leading-[14px] text-[color:var(--textBtn)];
}
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
.icon-lang-mobile {
  display: flex;
  width: 40px;
  height: 40px;
  justify-content: center;
  align-items: center;
  gap: 8px;
}
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 2px;
    object-fit: cover;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  background: #fff;
}
[theme-color="bk8"] .icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 2px;
    object-fit: cover;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  background: #fff;
}
.router-lint-active {
  .sidebar-text,
  .icon-angle-right {
    color: var(--selected) !important;
  }
}
.main-menu-active-container .menu-active {
  color: var(--primary);
}

.main-menu-active-container svg.menu-active {
  filter: var(--primary-filter);
}

.main-menu-active-container.menu-active::after {
  content: "";
  width: 2px;
  background-color: var(--primary);
  position: absolute;
  transform: translate(-4px, -50%);
  height: 12px;
  top: 50%;
  left: 0;
}
</style>
<style lang="scss">
body[layout-version="2"] {
  .main-menu-active-container svg.menu-active {
    filter: none;
  }
}
.sidebar-dialog.el-dialog {
  max-height: 100%;
  overflow-y: auto;

  .el-dialog__body:focus-visible {
    outline: transparent;
  }
}
.app-download-title {
  // width: 98px;
  height: 14px;
  font-style: normal;
  font-weight: bold;
  font-size: 12px;
  line-height: 14px;
  color: var(--text5);
}
.app-download-content {
  font-weight: 300;
  font-size: 10px;
  line-height: 14px;
  color: var(--text5);
}
.bg-app-download {
  @apply absolute w-40 h-[3.75rem] left-[100px] top-1 rounded-t-2xl;
}
.bg-theme-color {
  @apply rounded-t-2xl;
  background: var(--background3);
}
.sidebar-text {
  @apply h-4 font-normal leading-4 text-sm whitespace-nowrap overflow-ellipsis;
  color: var(--text5);
  text-transform: uppercase;
}
.m-profile-menu-item {
  border-bottom: 0.5px solid #393c68;
}
.m-profile-menu-item:last-child {
  border-bottom: none;
}
.m-angle-right-container {
  height: 21.83px;
  width: 21.83px;
  display: flex;
  justify-content: center;
  color: var(--text5);
}
.m-angle-right-container svg {
  font-size: 16.31px;
}
.profile-menu-title {
  font-size: 14px;
  color: var(--text);
  margin-left: 8.73px;
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}
.lang-wr-option-container {
  padding-bottom: 4.87px;
  margin-bottom: 27px !important;
}
.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}
[theme-color="bk8"] .bk8-downloadBtn {
  width: 78px !important;
  height: 30px !important;
}
[theme-color="bk8_green"] {
  .sidebar-dialog.el-dialog {
    margin-left: 0;
  }
  .sidebar .dialog-fade-enter-active {
    background: transparent;
    animation: sboFadeLeftToRight 1s ease backwards;
  }
  .sidebar .dialog-fade-leave-active {
    background: transparent;
    animation: sboFadeRightToLeft 2s ease backwards;
  }
  @keyframes sboFadeLeftToRight {
    0% {
      transform: translateX(-500px);
      opacity: 1;
    }

    100% {
      transform: translateX(0);
      opacity: 1;
    }
  }

  @keyframes sboFadeRightToLeft {
    0% {
      transform: translateX(0);
      opacity: 1;
    }

    100% {
      transform: translateX(-1000px);
      opacity: 1;
    }
  }
}
</style>
